/* This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010, 2011  Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Program by_sort1.c - Letter sorter
 *
 */

#include <stdio.h>                    
#include <stdlib.h>
#include <ctype.h>
#include "assertion.h"

/* clearing the sensors */
void pulseD5(void) 
{     
    int counter_1=0;
    int clo;
    clo=myclock();
    while (myclock()-clo<10)
    {
        counter_1++;
        };
 text_out("Clearing sensors");
 assertion("class",0);
 assertion("lsens",2);
 clo=myclock();
    while (myclock()-clo<10)
    {
        counter_1++;
        };
}

/* close solenoid */
void SolOn(int SolNo)
{
  assertion ("solon",SolNo);
}

/* opening solenoid */
void SolOff(int SolNo)
{
    assertion ("soloff",SolNo);
}  

/* delay for time units */
void Delay(int time, int dtype)
{
    int counter_1=0;
    int clo;
    char *temp;

    switch (dtype) {
        case 1 :
            temp = "delay1";
            break;

        case 2 :
            temp = "delay2";
            break;
        case 3 :
            temp = "delay3";
            break;
        case 4 :
            temp = "delay4";
            break;
        default:
            break;
    }
    
    clo=myclock();
    assertion(temp,0); 
     while (myclock()-clo<time)
    {
        counter_1++;
        };
        assertion(temp,1); 
    
}

/* sort second and first class letters into hoppers */
/* yellow = first and black = second */
void Sort_to_hoppers(int Dtime1, int Dtime2, int Dtime3, int Dtime4)
{
    int YellowSet,count; 
    int class_sensor, letter_sensor;
    YellowSet = 1;
    SolOn(4);
     
    for (count = 1; count < 3; count++)   /* error count, exit on 2 */ 
      {
      do
         {
         /* clear colour and letter sensor */
         pulseD5();
         scan_sensor ("class_sensor is ?",&class_sensor);
         if (class_sensor < 2) 
            { /* its yellow - activate solenoid 3 */
                assertion("class",1);
                SolOff(4);
                Delay(Dtime1,1);
                SolOn(4);
                Delay(Dtime4,4);
                scan_sensor ("letter sensor is ?",&letter_sensor);
                assertion("lsens",letter_sensor);
                if ( ! YellowSet)
                   {
                      Delay(Dtime2,2);
                      SolOff(3); 
                      Delay(Dtime3,3); YellowSet = 1;
                   }
             }  
         else
             { /* its black - deactivate solenoid 3 */
             assertion("class",2);
             SolOff(4);
             Delay(Dtime1,1);
             SolOn(4);
             Delay(Dtime4,4);
             scan_sensor("letter sensor is ?",&letter_sensor);
             assertion("lsens",letter_sensor);
             if( YellowSet)
                {
                Delay(Dtime2,2); 
                SolOn(3); 
                Delay(Dtime3,3); YellowSet = 0;
                }
              }   
         }
      /* repeat until no letter has passed letter sensor */
      while (letter_sensor != 0);
      }
    
   
}



/*----------------------------------------------------------------------------*
 * function main with parameters                                              *
 */
int main()
{
    int ch,delay4,delay3a,delay3b,delayf;
    printf ("Enter key : ?\n");
    scanf ("%d", &ch);
    printf ("Enter Delay4  : ?\n");
    scanf ("%d", &delay4);
    printf ("Enter Delay3A : ?\n");
    scanf ("%d", &delay3a);
    printf ("Enter Delay3B : ?\n");
    scanf ("%d", &delay3b);
    printf ("Enter DelayF  : ?\n");
    scanf ("%d", &delayf);
    Sort_to_hoppers(delay4,delay3a,delay3b,delayf);
        
}


