/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,
 * 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010, 2011  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * A pulse-generating circuit.  
 * Ben Moszkowski 
 */

define wave(A) = {
    if A=false then "|  " else " | "
}.

/* run */ define pulse_test() = exists W,X,Y,Z: {
    W=false and X=false and Y=false and
    for 5 times do {
	{
	    len(3) and stable W
	};
	{
	    skip and W:=not W
	}
    }
    and {X gets W} and {Y gets X} and {Z is (W and X and Y)}
    and format("%3s  %3s  %3s  %3s\n","Z","Y","X","W")
    and box format("%3s  %3s  %3s  %3s\n",wave(Z),wave(Y),wave(X),wave(W))
}.
